"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Decoration = void 0;

var _react = require("react");

var _three = require("three");

var _Motion = require("../Motion");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Decoration = function (_Component) {
  _inherits(Decoration, _Component);

  var _super = _createSuper(Decoration);

  function Decoration() {
    var _this;

    _classCallCheck(this, Decoration);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "setVisualState", function (state) {
      var vs = _this.calcVisualState(state);

      _this.visual.position.set(vs.position.x, vs.position.y, vs.position.z);

      if (!_this.isEmitter) {
        _this.visual.scale.set(vs.scale.x, vs.scale.y, vs.scale.z);
      }

      if (vs.lookAt) {
        _this.visual.lookAt(new _three.Vector3(vs.lookAt.x, vs.lookAt.y, vs.lookAt.z));
      } else {
        _this.visual.rotation.set(vs.rotation.x, vs.rotation.y, vs.rotation.z);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setStateValue", function (sv, vv) {
      return sv === undefined ? vv : Array.isArray(sv) ? _this.manager.isMobileScreen() ? sv[0] : sv[1] : sv;
    });

    _defineProperty(_assertThisInitialized(_this), "setAudio", function (audio) {
      var _this$manager = _this.manager,
          audioListener = _this$manager.audioListener,
          audioLoader = _this$manager.audioLoader;
      _this.audio = {};

      var _loop = function _loop(a) {
        var _audio$a = audio[a],
            src = _audio$a.src,
            refDistance = _audio$a.refDistance,
            maxDistance = _audio$a.maxDistance,
            volume = _audio$a.volume,
            loop = _audio$a.loop,
            play = _audio$a.play;
        _this.audio[a] = new _three.PositionalAudio(audioListener);
        audioLoader.load(src, function (buffer) {
          _this.audio[a].setBuffer(buffer);

          if (refDistance !== undefined) {
            _this.audio[a].setRefDistance(refDistance);
          }

          if (maxDistance !== undefined) {
            _this.audio[a].setMaxDistance(maxDistance);
          }

          if (volume !== undefined) {
            _this.audio[a].setVolume(volume);
          }

          if (loop !== undefined) {
            _this.audio[a].setLoop(loop);
          }

          if (play) {
            _this.audio[a].play();
          }

          _this.visual.add(_this.audio[a]);
        });
      };

      for (var a in audio) {
        _loop(a);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setMotion", function (motion) {
      _this.motion = new _Motion.Motion(_this.visual, motion);
    });

    _defineProperty(_assertThisInitialized(_this), "setActions", function (actions) {
      _this.actions = actions;

      _this.manager.connectActions(_assertThisInitialized(_this), actions);
    });

    _defineProperty(_assertThisInitialized(_this), "getActionState", function (a) {
      return _this.actions[a];
    });

    _defineProperty(_assertThisInitialized(_this), "calcVisualState", function (state) {
      var visPos = _this.visual.position;
      var visRot = _this.visual.rotation;
      var visScl = _this.visual.scale;
      var visState = {
        position: {
          x: visPos.x,
          y: visPos.y,
          z: visPos.z
        },
        rotation: {
          x: visRot.x,
          y: visRot.y,
          z: visRot.z
        },
        scale: {
          x: visScl.x,
          y: visScl.y,
          z: visScl.z
        }
      };

      if (state.position) {
        visState.position.x = _this.setStateValue(state.position.x, visPos.x);
        visState.position.y = _this.setStateValue(state.position.y, visPos.y);
        visState.position.z = _this.setStateValue(state.position.z, visPos.z);
      }

      if (state.scale) {
        visState.scale.x = _this.setStateValue(state.scale.x, visScl.x);
        visState.scale.y = _this.setStateValue(state.scale.y, visScl.y);
        visState.scale.z = _this.setStateValue(state.scale.z, visScl.z);
      }

      if (state.rotation) {
        visState.rotation.x = _this.setStateValue(state.rotation.x, visRot.x);
        visState.rotation.y = _this.setStateValue(state.rotation.y, visRot.y);
        visState.rotation.z = _this.setStateValue(state.rotation.z, visRot.z);
      } else if (state.lookAt) {
        visState.lookAt = {};
        visState.lookAt.x = _this.setStateValue(state.lookAt.x, 0);
        visState.lookAt.y = _this.setStateValue(state.lookAt.y, 0);
        visState.lookAt.z = _this.setStateValue(state.lookAt.z, 0);
      }

      return visState;
    });

    _defineProperty(_assertThisInitialized(_this), "update", function (onlyGlobal) {
      if (_this.isScene) {
        onlyGlobal = _this.id !== _this.manager.activeScene.id;
      }

      if ((!onlyGlobal || onlyGlobal && _this.isGlobal) && _this.motion) {
        _this.motion.update();
      }

      if (_this.isEmitter) {
        _this.nebula.update();
      }

      if (_this.children) {
        for (var c in _this.children) {
          _this.children[c].update(onlyGlobal);
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "connect", function (fiberNode) {
      var stateNode = fiberNode["return"].stateNode;

      if (!stateNode) {
        _this.connect(fiberNode["return"]);
      } else {
        if (!stateNode.visual) {
          _this.connect(stateNode._reactInternals);
        } else {
          if (_this.isEmitter) {
            _this.connectEmitter(stateNode);
          } else {
            stateNode.visual.add(_this.visual);
          }

          stateNode.children[_this.id] = _assertThisInitialized(_this);
          _this._compositionParentNode = stateNode;
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "find", function (id) {
      if (_this.id === id) return _assertThisInitialized(_this);
      if (!_this.children) return false;

      for (var k in _this.children) {
        var c = _this.children[k].find(id);

        if (c) return c;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "findAll", function (id) {
      var all = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      if (_this.id.includes(id)) all.push(_assertThisInitialized(_this));
      if (!_this.children) return false;

      for (var k in _this.children) {
        _this.children[k].findAll(id, all);
      }

      return all;
    });

    return _this;
  }

  _createClass(Decoration, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          id = _this$props.id,
          audio = _this$props.audio,
          motion = _this$props.motion,
          actions = _this$props.actions,
          layer = _this$props.layer,
          isGlobal = _this$props.isGlobal,
          isGLEvents = _this$props.isGLEvents,
          onClick = _this$props.onClick,
          onMouseOver = _this$props.onMouseOver;
      this.id = id || this.visual.uuid || this.visual.id;
      this.isGLEvents = this.isGLEvents || isGLEvents;
      this.isGlobal = isGlobal || false;
      this.isEmitter = this.visual.type === 'Emitter';
      this.setVisualState(this.props);
      if (audio) this.setAudio(audio);
      if (motion) this.setMotion(motion);
      if (actions) this.setActions(actions);
      if (onClick) this.visual.onClick = onClick;
      if (onMouseOver) this.visual.onMouseOver = onMouseOver;

      if (layer) {
        this.visual.layers.enable(layer);
        this.manager.layers[layer] = layer;
      }

      this.connect(this._reactInternals);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref) {
      var prevPosition = _ref.position,
          prevRotation = _ref.rotation,
          prevScale = _ref.scale,
          prevLookAt = _ref.lookAt,
          prevMotion = _ref.motion,
          prevActions = _ref.actions,
          prevMaterial = _ref.material,
          prevAudio = _ref.audio;
      var _this$props2 = this.props,
          position = _this$props2.position,
          rotation = _this$props2.rotation,
          scale = _this$props2.scale,
          lookAt = _this$props2.lookAt,
          motion = _this$props2.motion,
          actions = _this$props2.actions,
          material = _this$props2.material,
          audio = _this$props2.audio;

      if (JSON.stringify(position) !== JSON.stringify(prevPosition) || JSON.stringify(rotation) !== JSON.stringify(prevRotation) || JSON.stringify(scale) !== JSON.stringify(prevScale) || JSON.stringify(lookAt) !== JSON.stringify(prevLookAt)) {
        this.setVisualState({
          position: position,
          rotation: rotation,
          scale: scale,
          lookAt: lookAt
        });
      }

      if (JSON.stringify(motion) !== JSON.stringify(prevMotion)) {
        this.setMotion(motion);
      }

      if (JSON.stringify(actions) !== JSON.stringify(prevActions)) {
        this.setActions(actions);
      }

      if (JSON.stringify(material) !== JSON.stringify(prevMaterial)) {
        this.updateMaterial(material);
      }

      if (JSON.stringify(audio) !== JSON.stringify(prevAudio)) {
        for (var a in audio) {
          if (audio[a].play) {
            this.audio[a].play();
          } else if (this.audio[a].isPlaying) {
            this.audio[a].stop();
          }
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      for (var a in this.audio) {
        var _this$audio$a;

        if ((_this$audio$a = this.audio[a]) !== null && _this$audio$a !== void 0 && _this$audio$a.isPlaying) {
          this.audio[a].stop();
        }
      }

      if (this.isEmitter) {
        this.visual.parent.destroy();
      } else {
        this.visual.parent.remove(this.visual);
      }

      delete this._compositionParentNode.children[this.id];
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return Decoration;
}(_react.Component);

exports.Decoration = Decoration;