"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "EffectComposer", {
  enumerable: true,
  get: function get() {
    return _EffectComposer.EffectComposer;
  }
});
exports.Shaders = exports.Passes = void 0;

var _EffectComposer = require("three/examples/jsm/postprocessing/EffectComposer.js");

var _RenderPass = require("three/examples/jsm/postprocessing/RenderPass.js");

var _ShaderPass = require("three/examples/jsm/postprocessing/ShaderPass.js");

var _TexturePass = require("three/examples/jsm/postprocessing/TexturePass.js");

var _ClearPass = require("three/examples/jsm/postprocessing/ClearPass.js");

var _MaskPass = require("three/examples/jsm/postprocessing/MaskPass.js");

var _AdaptiveToneMappingPass = require("three/examples/jsm/postprocessing/AdaptiveToneMappingPass.js");

var _AfterimagePass = require("three/examples/jsm/postprocessing/AfterimagePass.js");

var _BloomPass = require("three/examples/jsm/postprocessing/BloomPass.js");

var _BokehPass = require("three/examples/jsm/postprocessing/BokehPass.js");

var _CubeTexturePass = require("three/examples/jsm/postprocessing/CubeTexturePass.js");

var _DotScreenPass = require("three/examples/jsm/postprocessing/DotScreenPass.js");

var _FilmPass = require("three/examples/jsm/postprocessing/FilmPass.js");

var _GlitchPass = require("three/examples/jsm/postprocessing/GlitchPass.js");

var _HalftonePass = require("three/examples/jsm/postprocessing/HalftonePass.js");

var _LUTPass = require("three/examples/jsm/postprocessing/LUTPass.js");

var _OutlinePass = require("three/examples/jsm/postprocessing/OutlinePass.js");

var _SAOPass = require("three/examples/jsm/postprocessing/SAOPass.js");

var _SavePass = require("three/examples/jsm/postprocessing/SavePass.js");

var _SMAAPass = require("three/examples/jsm/postprocessing/SMAAPass.js");

var _SSAARenderPass = require("three/examples/jsm/postprocessing/SSAARenderPass.js");

var _SSAOPass = require("three/examples/jsm/postprocessing/SSAOPass.js");

var _SSRPass = require("three/examples/jsm/postprocessing/SSRPass.js");

var _TAARenderPass = require("three/examples/jsm/postprocessing/TAARenderPass.js");

var _UnrealBloomPass = require("three/examples/jsm/postprocessing/UnrealBloomPass.js");

var _ACESFilmicToneMappingShader = require("three/examples/jsm/shaders/ACESFilmicToneMappingShader.js");

var _AfterimageShader = require("three/examples/jsm/shaders/AfterimageShader.js");

var _BasicShader = require("three/examples/jsm/shaders/BasicShader.js");

var _BleachBypassShader = require("three/examples/jsm/shaders/BleachBypassShader.js");

var _BlendShader = require("three/examples/jsm/shaders/BlendShader.js");

var _BokehShader = require("three/examples/jsm/shaders/BokehShader.js");

var _BrightnessContrastShader = require("three/examples/jsm/shaders/BrightnessContrastShader.js");

var _ColorCorrectionShader = require("three/examples/jsm/shaders/ColorCorrectionShader.js");

var _ColorifyShader = require("three/examples/jsm/shaders/ColorifyShader.js");

var _ConvolutionShader = require("three/examples/jsm/shaders/ConvolutionShader.js");

var _CopyShader = require("three/examples/jsm/shaders/CopyShader.js");

var _DepthLimitedBlurShader = require("three/examples/jsm/shaders/DepthLimitedBlurShader.js");

var _DOFMipMapShader = require("three/examples/jsm/shaders/DOFMipMapShader.js");

var _DotScreenShader = require("three/examples/jsm/shaders/DotScreenShader.js");

var _FilmShader = require("three/examples/jsm/shaders/FilmShader.js");

var _FocusShader = require("three/examples/jsm/shaders/FocusShader.js");

var _FreiChenShader = require("three/examples/jsm/shaders/FreiChenShader.js");

var _FXAAShader = require("three/examples/jsm/shaders/FXAAShader.js");

var _GammaCorrectionShader = require("three/examples/jsm/shaders/GammaCorrectionShader.js");

var _HalftoneShader = require("three/examples/jsm/shaders/HalftoneShader.js");

var _HorizontalBlurShader = require("three/examples/jsm/shaders/HorizontalBlurShader.js");

var _HorizontalTiltShiftShader = require("three/examples/jsm/shaders/HorizontalTiltShiftShader.js");

var _HueSaturationShader = require("three/examples/jsm/shaders/HueSaturationShader.js");

var _KaleidoShader = require("three/examples/jsm/shaders/KaleidoShader.js");

var _LuminosityHighPassShader = require("three/examples/jsm/shaders/LuminosityHighPassShader.js");

var _LuminosityShader = require("three/examples/jsm/shaders/LuminosityShader.js");

var _MirrorShader = require("three/examples/jsm/shaders/MirrorShader.js");

var _MMDToonShader = require("three/examples/jsm/shaders/MMDToonShader.js");

var _NormalMapShader = require("three/examples/jsm/shaders/NormalMapShader.js");

var _PixelShader = require("three/examples/jsm/shaders/PixelShader.js");

var _RGBShiftShader = require("three/examples/jsm/shaders/RGBShiftShader.js");

var _SAOShader = require("three/examples/jsm/shaders/SAOShader.js");

var _SepiaShader = require("three/examples/jsm/shaders/SepiaShader.js");

var _SobelOperatorShader = require("three/examples/jsm/shaders/SobelOperatorShader.js");

var _SubsurfaceScatteringShader = require("three/examples/jsm/shaders/SubsurfaceScatteringShader.js");

var _TechnicolorShader = require("three/examples/jsm/shaders/TechnicolorShader.js");

var _ToneMapShader = require("three/examples/jsm/shaders/ToneMapShader.js");

var _TriangleBlurShader = require("three/examples/jsm/shaders/TriangleBlurShader.js");

var _UnpackDepthRGBAShader = require("three/examples/jsm/shaders/UnpackDepthRGBAShader.js");

var _VerticalBlurShader = require("three/examples/jsm/shaders/VerticalBlurShader.js");

var _VerticalTiltShiftShader = require("three/examples/jsm/shaders/VerticalTiltShiftShader.js");

var _VignetteShader = require("three/examples/jsm/shaders/VignetteShader.js");

var _WaterRefractionShader = require("three/examples/jsm/shaders/WaterRefractionShader.js");

var _DigitalGlitch = require("three/examples/jsm/shaders/DigitalGlitch.js");

var _GodRaysShader = require("three/examples/jsm/shaders/GodRaysShader.js");

var _SMAAShader = require("three/examples/jsm/shaders/SMAAShader.js");

var _SSAOShader = require("three/examples/jsm/shaders/SSAOShader.js");

var _SSRShader = require("three/examples/jsm/shaders/SSRShader.js");

var _ToonShader = require("three/examples/jsm/shaders/ToonShader.js");

var Passes = {
  Pass: _EffectComposer.Pass,
  RenderPass: _RenderPass.RenderPass,
  ShaderPass: _ShaderPass.ShaderPass,
  TexturePass: _TexturePass.TexturePass,
  ClearPass: _ClearPass.ClearPass,
  MaskPass: _MaskPass.MaskPass,
  ClearMaskPass: _MaskPass.ClearMaskPass,
  AdaptiveToneMappingPass: _AdaptiveToneMappingPass.AdaptiveToneMappingPass,
  AfterimagePass: _AfterimagePass.AfterimagePass,
  BloomPass: _BloomPass.BloomPass,
  BokehPass: _BokehPass.BokehPass,
  CubeTexturePass: _CubeTexturePass.CubeTexturePass,
  DotScreenPass: _DotScreenPass.DotScreenPass,
  FilmPass: _FilmPass.FilmPass,
  GlitchPass: _GlitchPass.GlitchPass,
  HalftonePass: _HalftonePass.HalftonePass,
  LUTPass: _LUTPass.LUTPass,
  OutlinePass: _OutlinePass.OutlinePass,
  SAOPass: _SAOPass.SAOPass,
  SavePass: _SavePass.SavePass,
  SMAAPass: _SMAAPass.SMAAPass,
  SSAARenderPass: _SSAARenderPass.SSAARenderPass,
  SSAOPass: _SSAOPass.SSAOPass,
  SSRPass: _SSRPass.SSRPass,
  TAARenderPass: _TAARenderPass.TAARenderPass,
  UnrealBloomPass: _UnrealBloomPass.UnrealBloomPass
};
exports.Passes = Passes;
var Shaders = {
  ACESFilmicToneMappingShader: _ACESFilmicToneMappingShader.ACESFilmicToneMappingShader,
  AfterimageShader: _AfterimageShader.AfterimageShader,
  BasicShader: _BasicShader.BasicShader,
  BleachBypassShader: _BleachBypassShader.BleachBypassShader,
  BlendShader: _BlendShader.BlendShader,
  BokehShader: _BokehShader.BokehShader,
  BrightnessContrastShader: _BrightnessContrastShader.BrightnessContrastShader,
  ColorCorrectionShader: _ColorCorrectionShader.ColorCorrectionShader,
  ColorifyShader: _ColorifyShader.ColorifyShader,
  ConvolutionShader: _ConvolutionShader.ConvolutionShader,
  CopyShader: _CopyShader.CopyShader,
  DepthLimitedBlurShader: _DepthLimitedBlurShader.DepthLimitedBlurShader,
  DigitalGlitchShader: _DigitalGlitch.DigitalGlitch,
  DOFMipMapShader: _DOFMipMapShader.DOFMipMapShader,
  DotScreenShader: _DotScreenShader.DotScreenShader,
  FilmShader: _FilmShader.FilmShader,
  FocusShader: _FocusShader.FocusShader,
  FreiChenShader: _FreiChenShader.FreiChenShader,
  FXAAShader: _FXAAShader.FXAAShader,
  GammaCorrectionShader: _GammaCorrectionShader.GammaCorrectionShader,
  GodRaysDepthMaskShader: _GodRaysShader.GodRaysDepthMaskShader,
  GodRaysGenerateShader: _GodRaysShader.GodRaysGenerateShader,
  GodRaysCombineShader: _GodRaysShader.GodRaysCombineShader,
  GodRaysFakeSunShader: _GodRaysShader.GodRaysFakeSunShader,
  HalftoneShader: _HalftoneShader.HalftoneShader,
  HorizontalBlurShader: _HorizontalBlurShader.HorizontalBlurShader,
  HorizontalTiltShiftShader: _HorizontalTiltShiftShader.HorizontalTiltShiftShader,
  HueSaturationShader: _HueSaturationShader.HueSaturationShader,
  KaleidoShader: _KaleidoShader.KaleidoShader,
  LuminosityHighPassShader: _LuminosityHighPassShader.LuminosityHighPassShader,
  LuminosityShader: _LuminosityShader.LuminosityShader,
  MirrorShader: _MirrorShader.MirrorShader,
  MMDToonShader: _MMDToonShader.MMDToonShader,
  NormalMapShader: _NormalMapShader.NormalMapShader,
  PixelShader: _PixelShader.PixelShader,
  RGBShiftShader: _RGBShiftShader.RGBShiftShader,
  SAOShader: _SAOShader.SAOShader,
  SepiaShader: _SepiaShader.SepiaShader,
  SMAAEdgesShader: _SMAAShader.SMAAEdgesShader,
  SMAAWeightsShader: _SMAAShader.SMAAWeightsShader,
  SMAABlendShader: _SMAAShader.SMAABlendShader,
  SobelOperatorShader: _SobelOperatorShader.SobelOperatorShader,
  SSAOShader: _SSAOShader.SSAOShader,
  SSAODepthShader: _SSAOShader.SSAODepthShader,
  SSAOBlurShader: _SSAOShader.SSAOBlurShader,
  SSRShader: _SSRShader.SSRShader,
  SSRDepthShader: _SSRShader.SSRDepthShader,
  SSRBlurShader: _SSRShader.SSRBlurShader,
  SubsurfaceScatteringShader: _SubsurfaceScatteringShader.SubsurfaceScatteringShader,
  TechnicolorShader: _TechnicolorShader.TechnicolorShader,
  ToneMapShader: _ToneMapShader.ToneMapShader,
  ToonShaderHatching: _ToonShader.ToonShaderHatching,
  ToonShaderDotted: _ToonShader.ToonShaderDotted,
  TriangleBlurShader: _TriangleBlurShader.TriangleBlurShader,
  UnpackDepthRGBAShader: _UnpackDepthRGBAShader.UnpackDepthRGBAShader,
  VerticalBlurShader: _VerticalBlurShader.VerticalBlurShader,
  VerticalTiltShiftShader: _VerticalTiltShiftShader.VerticalTiltShiftShader,
  VignetteShader: _VignetteShader.VignetteShader,
  WaterRefractionShader: _WaterRefractionShader.WaterRefractionShader
};
exports.Shaders = Shaders;