"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.basicMaterialTypes = exports.basicGeometryTypes = exports.Loaders = void 0;

var _AMFLoader = require("three/examples/jsm/loaders/AMFLoader.js");

var _BasisTextureLoader = require("three/examples/jsm/loaders/BasisTextureLoader.js");

var _BVHLoader = require("three/examples/jsm/loaders/BVHLoader.js");

var _ColladaLoader = require("three/examples/jsm/loaders/ColladaLoader.js");

var _DDSLoader = require("three/examples/jsm/loaders/DDSLoader.js");

var _DRACOLoader = require("three/examples/jsm/loaders/DRACOLoader.js");

var _EXRLoader = require("three/examples/jsm/loaders/EXRLoader.js");

var _FBXLoader = require("three/examples/jsm/loaders/FBXLoader.js");

var _FontLoader = require("three/examples/jsm/loaders/FontLoader.js");

var _GCodeLoader = require("three/examples/jsm/loaders/GCodeLoader.js");

var _GLTFLoader = require("three/examples/jsm/loaders/GLTFLoader.js");

var _HDRCubeTextureLoader = require("three/examples/jsm/loaders/HDRCubeTextureLoader.js");

var _IFCLoader = require("three/examples/jsm/loaders/IFCLoader.js");

var _KMZLoader = require("three/examples/jsm/loaders/KMZLoader.js");

var _KTX2Loader = require("three/examples/jsm/loaders/KTX2Loader.js");

var _KTXLoader = require("three/examples/jsm/loaders/KTXLoader.js");

var _LDrawLoader = require("three/examples/jsm/loaders/LDrawLoader.js");

var _LogLuvLoader = require("three/examples/jsm/loaders/LogLuvLoader.js");

var _LottieLoader = require("three/examples/jsm/loaders/LottieLoader.js");

var _LUT3dlLoader = require("three/examples/jsm/loaders/LUT3dlLoader.js");

var _LUTCubeLoader = require("three/examples/jsm/loaders/LUTCubeLoader.js");

var _LWOLoader = require("three/examples/jsm/loaders/LWOLoader.js");

var _MD2Loader = require("three/examples/jsm/loaders/MD2Loader.js");

var _MDDLoader = require("three/examples/jsm/loaders/MDDLoader.js");

var _MMDLoader = require("three/examples/jsm/loaders/MMDLoader.js");

var _MTLLoader = require("three/examples/jsm/loaders/MTLLoader.js");

var _NRRDLoader = require("three/examples/jsm/loaders/NRRDLoader.js");

var _OBJLoader = require("three/examples/jsm/loaders/OBJLoader.js");

var _PCDLoader = require("three/examples/jsm/loaders/PCDLoader.js");

var _PDBLoader = require("three/examples/jsm/loaders/PDBLoader.js");

var _PLYLoader = require("three/examples/jsm/loaders/PLYLoader.js");

var _PRWMLoader = require("three/examples/jsm/loaders/PRWMLoader.js");

var _PVRLoader = require("three/examples/jsm/loaders/PVRLoader.js");

var _RGBELoader = require("three/examples/jsm/loaders/RGBELoader.js");

var _RGBMLoader = require("three/examples/jsm/loaders/RGBMLoader.js");

var _DMLoader = require("three/examples/jsm/loaders/3DMLoader.js");

var _STLLoader = require("three/examples/jsm/loaders/STLLoader.js");

var _SVGLoader = require("three/examples/jsm/loaders/SVGLoader.js");

var _TDSLoader = require("three/examples/jsm/loaders/TDSLoader.js");

var _TGALoader = require("three/examples/jsm/loaders/TGALoader.js");

var _MFLoader = require("three/examples/jsm/loaders/3MFLoader.js");

var _TiltLoader = require("three/examples/jsm/loaders/TiltLoader.js");

var _TTFLoader = require("three/examples/jsm/loaders/TTFLoader.js");

var _VOXLoader = require("three/examples/jsm/loaders/VOXLoader.js");

var _VRMLLoader = require("three/examples/jsm/loaders/VRMLLoader.js");

var _VTKLoader = require("three/examples/jsm/loaders/VTKLoader.js");

var _XYZLoader = require("three/examples/jsm/loaders/XYZLoader.js");

var Loaders = {
  AMFLoader: _AMFLoader.AMFLoader,
  BasisTextureLoader: _BasisTextureLoader.BasisTextureLoader,
  BVHLoader: _BVHLoader.BVHLoader,
  ColladaLoader: _ColladaLoader.ColladaLoader,
  DDSLoader: _DDSLoader.DDSLoader,
  DRACOLoader: _DRACOLoader.DRACOLoader,
  EXRLoader: _EXRLoader.EXRLoader,
  FBXLoader: _FBXLoader.FBXLoader,
  FontLoader: _FontLoader.FontLoader,
  GCodeLoader: _GCodeLoader.GCodeLoader,
  GLTFLoader: _GLTFLoader.GLTFLoader,
  HDRCubeTextureLoader: _HDRCubeTextureLoader.HDRCubeTextureLoader,
  IFCLoader: _IFCLoader.IFCLoader,
  KMZLoader: _KMZLoader.KMZLoader,
  KTX2Loader: _KTX2Loader.KTX2Loader,
  KTXLoader: _KTXLoader.KTXLoader,
  LDrawLoader: _LDrawLoader.LDrawLoader,
  LogLuvLoader: _LogLuvLoader.LogLuvLoader,
  LottieLoader: _LottieLoader.LottieLoader,
  LUT3dlLoader: _LUT3dlLoader.LUT3dlLoader,
  LUTCubeLoader: _LUTCubeLoader.LUTCubeLoader,
  LWOLoader: _LWOLoader.LWOLoader,
  MD2Loader: _MD2Loader.MD2Loader,
  MDDLoader: _MDDLoader.MDDLoader,
  MMDLoader: _MMDLoader.MMDLoader,
  MTLLoader: _MTLLoader.MTLLoader,
  NRRDLoader: _NRRDLoader.NRRDLoader,
  OBJLoader: _OBJLoader.OBJLoader,
  PCDLoader: _PCDLoader.PCDLoader,
  PDBLoader: _PDBLoader.PDBLoader,
  PLYLoader: _PLYLoader.PLYLoader,
  PRWMLoader: _PRWMLoader.PRWMLoader,
  PVRLoader: _PVRLoader.PVRLoader,
  RGBELoader: _RGBELoader.RGBELoader,
  RGBMLoader: _RGBMLoader.RGBMLoader,
  Rhino3dmLoader: _DMLoader.Rhino3dmLoader,
  STLLoader: _STLLoader.STLLoader,
  SVGLoader: _SVGLoader.SVGLoader,
  TDSLoader: _TDSLoader.TDSLoader,
  TGALoader: _TGALoader.TGALoader,
  ThreeMFLoader: _MFLoader.ThreeMFLoader,
  TiltLoader: _TiltLoader.TiltLoader,
  TTFLoader: _TTFLoader.TTFLoader,
  VOXLoader: _VOXLoader.VOXLoader,
  VRMLLoader: _VRMLLoader.VRMLLoader,
  VTKLoader: _VTKLoader.VTKLoader,
  XYZLoader: _XYZLoader.XYZLoader
};
exports.Loaders = Loaders;
var basicMaterialTypes = ['basic', 'depth', 'distance', 'lambert', 'matcap', 'normal', 'phong', 'physical', 'standard', 'toon'];
exports.basicMaterialTypes = basicMaterialTypes;
var basicGeometryTypes = ['box', 'capsule', 'circle', 'cone', 'cylinder', 'dodecahedron', 'extrude', 'icosahedron', 'lathe', 'octahedron', 'plane', 'polyhedron', 'ring', 'shape', 'sphere', 'tetrahedron', 'torus', 'torusknot', 'tube'];
exports.basicGeometryTypes = basicGeometryTypes;